from nmubxlib.frame import UbxFrame, UbxCID
from nmubxlib.types import X2, X4, U1, U2, U4, Padding


class UbxCfgEsfGawt_(UbxFrame):
    CID = UbxCID(0x06, 0x2D)
    NAME = 'UBX-CFG-ESFGAWT'


class UbxCfgEsfGawtPoll(UbxCfgEsfGawt_):
    NAME = UbxCfgEsfGawt_.NAME + '-POLL'

    def __init__(self):
        super().__init__()


class UbxCfgEsfGawt(UbxCfgEsfGawt_):
    MASK_useWtPin = 1 << 13
    MASK_useWtSpeed = 1 << 10

    def __init__(self):
        super().__init__()

        self.f.add(U1('version'))
        self.f.add(U1('id'))
        self.f.add(X2('flags'))
        self.f.add(U4('senTtagFactor'))     # 1e-6
        self.f.add(U4('senTtagMax'))
        self.f.add(U4('wtFactor'))          # 1e-6
        self.f.add(U4('wtQuantError'))      # 1e-6, m (or m/s)
        self.f.add(U4('wtCountMax'))
        self.f.add(U2('wtLatency'))         # ms
        self.f.add(U1('wtFrequency'))       # Hz
        self.f.add(U1('gyroFrequency'))     # Hz
        self.f.add(U2('gyroAcc'))           # 1e-3, deg/s
        self.f.add(U2('gyroLatency'))       # ms
        self.f.add(U2('accelAcc'))          # 1e-4, m/s
        self.f.add(U2('accelLatency'))      # ms
        self.f.add(U1('accelFrequency'))    # Hz
        self.f.add(U1('reserved1'))
        self.f.add(U2('speedDeadBand'))     # cm/s
        self.f.add(U2('tcTableSaveRate'))   # s
        self.f.add(U1('gyroRmsThdl'))       # 2^-8, deg/s
        self.f.add(U1('accelRmsThdl'))      # 2^-6, m/s
        self.f.add(X4('flags2'))
        self.f.add(Padding(4, 'reserved2'))

    # TODO:
    # def enableUseWtPin()
    # def disableUseWtPin()
    # def enableUseWtSpeed()
    # def disableUseWtSpeed()
