from nmubxlib.cid import UbxCID
from nmubxlib.frame import UbxFrame
from nmubxlib.types import U1


class UbxCfgHnr_(UbxFrame):
    CID = UbxCID(UbxCID.CLASS_CFG, 0x5C)
    NAME = 'UBX-CFG-HNR'


class UbxCfgHnrPoll(UbxCfgHnr_):
    NAME = UbxCfgHnr_.NAME + '-POLL'

    def __init__(self):
        super().__init__()

    def _cls_response(self):
        return UbxCfgHnr


class UbxCfgHnr(UbxCfgHnr_):
    def __init__(self):
        super().__init__()

        self.f.add(U1('highNavRate'))
        self.f.add(U1('res1'))
        self.f.add(U1('res2'))
        self.f.add(U1('res3'))

    def set_rate_in_hz(self, rate):
        self.f.highNavRate = rate

    def get_rate_in_hz(self):
        return self.f.highNavRate
